package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.test.http;

import com.fasterxml.jackson.databind.ObjectMapper;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.Application;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.vo.TwoParamIdCardRequestObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty_interface.vo.CustomBodyObject;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.context.web.WebAppConfiguration;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.result.MockMvcResultHandlers;
import org.springframework.test.web.servlet.result.MockMvcResultMatchers;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;
import org.springframework.web.context.WebApplicationContext;

import java.io.IOException;
import java.util.Scanner;
@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
@WebAppConfiguration
public class ActionService {
    private MockMvc mockMvc;

    @Autowired
    private WebApplicationContext context;
    @Autowired
    private ObjectMapper objectMapper;


    @Before
    public void before() throws Exception {
        mockMvc = MockMvcBuilders.webAppContextSetup(context).build();
    }

    @Test
    public void checkIdCardForBTY() throws Exception {
        CustomBodyObject twoParamIdCardRequestObject = new CustomBodyObject();
        String channelId = "1000001";
        twoParamIdCardRequestObject.setIdCode("41xexstesfss");
        twoParamIdCardRequestObject.setName("chen");
        twoParamIdCardRequestObject.setPlateNumber("1111");
        String customBody = objectMapper.writeValueAsString(twoParamIdCardRequestObject);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/checkIdCardForBTY.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }

    @Test
    public void checkIdCardWeiZhong() throws Exception {
        CustomBodyObject twoParamIdCardRequestObject = new CustomBodyObject();
        String channelId = "1000001";
        twoParamIdCardRequestObject.setIdCode("41xexstesfss");
        twoParamIdCardRequestObject.setName("chen");
        twoParamIdCardRequestObject.setPlateNumber("1111");
        String customBody = objectMapper.writeValueAsString(twoParamIdCardRequestObject);
        mockMvc.perform(
                MockMvcRequestBuilders.post("/checkIdCardWeiZhong.do")
                        .header("channelId",channelId)
                        .param("outTime", "1000")
                        .param("customBody", customBody)
        )
                .andExpect(MockMvcResultMatchers.status().isOk())
                .andDo(MockMvcResultHandlers.print());

    }

}
