package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.test.serviceTest;

import com.fasterxml.jackson.databind.ObjectMapper;
import info.aspirecn.iov.sjjh.commons.lang.ChannelTypeHandleResponseObject;
import info.aspirecn.iov.sjjh.commons.lang.Constant;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.Application;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.service.BTYChannelService;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty.vo.TwoParamIdCardResponseObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty_interface.vo.CustomBodyObject;
import info.aspirecn.rdc.iov.sjjh.servicenode.supplier.bty_interface.vo.ResponseObject;
import lombok.extern.slf4j.Slf4j;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.test.context.junit4.SpringRunner;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;

/**
 * @Auther jianggang
 * @Date 2018/10/25 14:33:50
 * @Description
 */

@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
@Slf4j
public class BTYChannelServiceTest {

    @Autowired
    BTYChannelService btyChannelService;

    @Test
    public void sendTwoParamIdCardRequestTest() throws IOException {
        CustomBodyObject customBodyObject = new CustomBodyObject();
        customBodyObject.setName("江港");
        customBodyObject.setIdCode("421022199701017517");
        ObjectMapper mapper = new ObjectMapper();
        String customBodyString = mapper.writeValueAsString(customBodyObject);

        MockHttpServletRequest request = new MockHttpServletRequest();
        request.addHeader(Constant.CUSTOMER_RETURN_TYPE_PARA,1);
        ChannelTypeHandleResponseObject responseObject = btyChannelService.sendTwoParamIdCardRequest(request,"20000002",1000,customBodyString);
        log.info("responseObject========>{}",responseObject.toString());
        Assert.assertEquals((int)responseObject.getCode(),Constant.SUCCESS);
        Assert.assertEquals((int)responseObject.getIsCharge(),Constant.INTERFACE_QUERY_FEE);
        Assert.assertEquals(((TwoParamIdCardResponseObject)responseObject.getResultBody()).getCode(),"100");
        Assert.assertEquals(((TwoParamIdCardResponseObject)responseObject.getResultBody()).getData().getResult(),"一致");
    }
    @Test
    public void checkIdCardWeiZhongTest() throws IOException {
        CustomBodyObject customBodyObject = new CustomBodyObject();
        customBodyObject.setName("江港");
        customBodyObject.setIdCode("421022199701017517");
        ObjectMapper mapper = new ObjectMapper();
        String customBodyString = mapper.writeValueAsString(customBodyObject);

        MockHttpServletRequest request = new MockHttpServletRequest();
        request.addHeader(Constant.CUSTOMER_RETURN_TYPE_PARA,1);
        ChannelTypeHandleResponseObject responseObject = btyChannelService.checkIdCardWeiZhong(request,"20000002",1000,customBodyString);
        log.info("responseObject========>{}",responseObject.toString());
        Assert.assertEquals((int)responseObject.getCode(),Constant.SUCCESS);
        Assert.assertEquals((int)responseObject.getIsCharge(),Constant.INTERFACE_QUERY_FEE);
        Assert.assertEquals(((TwoParamIdCardResponseObject)responseObject.getResultBody()).getCode(),"100");
        Assert.assertEquals(((TwoParamIdCardResponseObject)responseObject.getResultBody()).getData().getResult(),"一致");
    }
}
